/* ########################################################################

			javascript mode

   File: javascript.sc
   Path: /mnt/LaCie/xcoral-3.49.61/SmacLib/javascript.sc
   Description: 
   Created: sam. mai  2 15:37:49 CEST 2020
   Author: lionel fournigault
   Modified: sam. mai  2 15:49:57 CEST 2020
   Last maintained by: lionel fournigault

   RCS $Revision$ $State$
   

   ########################################################################

   Note: javascript_color_region is defined in color.sc

   javascript_new_line: return and indent
   javascript_indent_line: Tab key to indent line
   javascript_indent_region: use mark to indent rgion
	 

   ########################################################################

   Copyright (c) : lionel fournigault

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */

int javascript_indent_step = 4;

char * javascript_regexp_indent = 
  "default\\|case\\|if\\|else\\|for\\|while\\|{\\|do\\|try\\|catch";
char * javascript_regexp_indent2 =
  "if\\|else\\|for\\|while\\|do\\|try\\|{\\|catch";

char * javascript_string = "\'.*\'\\|\".*\""; /* replace gen_string */

/* ================================================================================
   Return line number at position. First line of buffer = 0
   ================================================================================ */
int javascript_no_line_at_pos ( int position ) {

  int pos = 0, n = 0;
		     
  while(pos != end_of_file()) {
    if (pos == position){
      return n;
    }
    if (the_char(pos) == '\n')
      n += 1;
    pos += 1;
  }
  return n;
}

/* ================================================================================
   Search position inside regexp. Return 1 if position is inside regexp else 0
   ================================================================================ */
int javascript_pos_in_regexp ( char *regexp, int nsub, int position ) {

  int orig = current_position();
  int pos, re_begin, re_end;

  goto_char(0);
  while (1) {
    pos = re_forward_search (regexp);
    if ((pos == -1) || (pos == -2) || (pos >= end_of_file()))
      break;
    
    if (pos > position){
      goto_char (orig);
      return 0;
    }
    
    re_begin = re_match_beginning(nsub);
    re_end = re_match_end(nsub);
    
    if ( position >= re_begin && position <= re_end ) {
      /* Bingo */
      goto_char (orig);
      return 1;
    }

    if (re_end == end_of_file())
      break;
    else
      goto_char(re_end + 1);
  }
  goto_char (orig);
  return 0;
}

/* ================================================================================
   Search position inside multi-lines comment.
   Return 1 if position is inside comment else 0
   ================================================================================ */
int javascript_pos_in_comment (char *re_begin_comment, char *re_end_comment, int position) {

  int orig = current_position ();
  int begin_comment, end_comment, pos;

  goto_char(0);
  while (1) {
    pos = re_forward_search (re_cpp_begin_comment);
    if ((pos == -1) || (pos == -2) || (pos >= end_of_file())){
      goto_char (orig);
      return 0;
      break;
    }
    
    begin_comment = re_match_beginning(0);
    if (begin_comment >= end_of_file())
      break;
    
    goto_char (begin_comment);
    
    /* Recherche de la fin du commentaire */
    pos = re_forward_search (re_cpp_end_comment);
    if ((pos == -1) || (pos == -2) || (pos > end_of_file()))
      break;
    
    end_comment = (re_match_end(0) > end_of_file()) ? end_of_file() : re_match_end(0);
    
    if (position > begin_comment && position < end_comment){
      /* Bingo */
      goto_char (orig);
      return 1;
    }
    
    goto_char (end_comment);
    
    if (current_position() >= end_of_file())
      break;
  }
  goto_char (orig);
  return 0;
}

/* ================================================================================
   Search blinkchar backward in the buffer. Return position or -1 
   ================================================================================ */
int javascript_pos_blink_char ( int blink_char, int c ) {
  
  int pos, c_char, pos_blink = -1, internal = 0;
  
  pos = current_position();
  
  if (pos < 2)
    return;
  else
    pos -= 2;
  
  if (pos == 0 && the_char(pos) == blink_char)
    pos_blink = 0;
  
  while ( pos >= 0 ){
    c_char = the_char(pos);
    
    if ( c_char == blink_char ) {
      if ( javascript_pos_in_comment( re_cpp_begin_comment, re_cpp_end_comment, pos ) == 0 
	  && javascript_pos_in_regexp ( "//.*$", 0, pos ) == 0 
	  && javascript_pos_in_regexp ( javascript_string, 0, pos ) == 0 ) {
	if (internal == 0) {
	  pos_blink = pos;
	  break;
	}
	else {
	  internal -= 1;
	}
      }
    }
    else if (c_char == c ) {
      if ( javascript_pos_in_comment( re_cpp_begin_comment, re_cpp_end_comment, pos ) == 0 
	  && javascript_pos_in_regexp ( "//.*$", 0, pos ) == 0 
	  && javascript_pos_in_regexp ( javascript_string, 0, pos ) == 0 ) {
	internal += 1;
      }
    }
    else
      ;
    pos -= 1;
  }
  return pos_blink;
}

/* ================================================================================
   Align two lines. Use after blink for exemple.
   ================================================================================ */
void javascript_align_lines ( int ref_pos, int orig ) {

  int pos, c;
  int count = 0;

  if (javascript_no_line_at_pos(ref_pos) == javascript_no_line_at_pos(orig))
    return;

  /* line to align */
  goto_beginning_of_line();
  pos = current_position();
  while (pos != end_of_line()){
    if ( the_char(pos) == ' ' || the_char(pos) == '\t' ) {
      delete_char();
      count -= 1;
      pos = current_position();
    }
    else
      break;
  }

  /* Reference line */
  pos = ref_pos;
  if (the_char(pos) == '\n')
    pos -= 1;
  
  while (1) {
    if (the_char(pos) == '\n'){
      pos += 1;
      break;
    }
    if (pos == 0)
      break;
    pos -= 1;
  }
  
  while (1) {
    c = the_char(pos);
    if ( c == ' ' || c == '\t' ) {
      insert_char(c);
      count += 1;
    }
    else
      break;
    pos += 1;
  }
  goto_char ( orig + count );
}

/* ================================================================================
   Return first character in line (not blank space or tab)
   ================================================================================ */
char javascript_first_char_in_line ( int line ) {
  
  int pos = current_position();
  int tmp_pos;
  
  if (current_line() != line)
    goto_line(line);
  
  if ( beginning_of_line() ==  end_of_line() ){
    goto_char (pos);
    return '\n';
  }
  else
    goto_beginning_of_line();

  while (1){
    if (current_position() == end_of_line()){
     goto_char (pos);
     return '\n';
    }
    if (the_char(current_position()) != ' ' 
	&& the_char(current_position()) != '\t'){
      tmp_pos = current_position();
      goto_char (pos);
      return the_char(tmp_pos);
    }
    else
      goto_next_char();
  }
}

/* ================================================================================
   Return last character in current line (not blank space or tab)
   Ignore single line comment
   ================================================================================ */
char javascript_last_char_in_line() {
  
  int pos = end_of_line();
  
  if (pos == beginning_of_line()) /* empty line */
      return '\n';
  else
    pos -= 1;
      
  while (1) {
    if ( pos == beginning_of_line() )
      break;
    if (the_char(pos) == ' ' || the_char(pos)== '\t'
	|| javascript_pos_in_regexp ( "//.*$", 0, pos ) == 1 )
      pos -= 1;
    else
      break;
  }
  return the_char(pos);
}

/* ================================================================================
   Return distance from end of line. 
   ================================================================================ */
int javascript_distance_from_end_of_line (int pos) {
  
  int distance = 0, tmp_pos;
  
  if (end_of_line() == beginning_of_line())
    distance = 0;
    
  tmp_pos = end_of_line();
  while (tmp_pos != beginning_of_line()){
    if (pos == tmp_pos)
      break;
    else
      distance += 1;
    tmp_pos -= 1;
  }
  /* a partir d'ici tmp_pos = pos ou debut de ligne */
  tmp_pos = beginning_of_line();
  while (tmp_pos != end_of_line()){
    if (the_char(tmp_pos) != ' ' && the_char(tmp_pos) != '\t'){
      break;
    }
    else {
      tmp_pos += 1;
     }
  }
  if (tmp_pos > pos)
    distance -= tmp_pos - pos;

  return distance;
}

/* ================================================================================
   Align to previous line.
   ================================================================================ */
void javascript_align_to_previous_line() {
  
  int pos, c;

  if (current_line() == 0)
    return;
  /* Remove ' ' or tab at the beginning of line */
  goto_beginning_of_line();
  while(current_char()==' ' || current_char()=='\t'){
    if (current_position() == end_of_line())
      break;
    delete_char();
  }
  
  /* Use indent of previous line */  
  goto_previous_line();
  goto_beginning_of_line();
  pos = current_position();
  goto_next_line();
  goto_beginning_of_line();
  
  while (strchr(" \t", c = the_char(pos))) {
    if (pos == end_of_line())
      break;
    insert_char(c);
    pos += 1;
  } 
}

/* ================================================================================
   Return pos blink line. Multi-lines parantheses before blink
   ================================================================================ */
int javascript_pos_line_blink (int orig) {

  int tmp_pos,  pos = orig;
  int pos_blink = pos;

  goto_char(orig);
  /* on est sur le blink caractre { */
  /* recherche d'une parenthse fermante dans la ligne courante */

  while (1){
    goto_previous_char();
    tmp_pos = current_position();
    if (tmp_pos == beginning_of_line())
      break;
    if ( the_char(tmp_pos) == ' ' || the_char(tmp_pos) == '\t' )
      continue;
    else
      break;
  }

  if (the_char(tmp_pos) == ')') {
    goto_char(tmp_pos+1);   
    pos_blink = javascript_pos_blink_char ('(', ')');
    if (pos_blink == -1)
      pos_blink = pos;
  }
  goto_char(orig);
  return pos_blink;
}

/* ================================================================================
   Align close bracket
   ================================================================================ */
void javascript_align_close_bracket(int orig) {
  
  int pos, tmp_pos, pos_blink;
  
  goto_beginning_of_line();
  tmp_pos = current_position();
  while (1){
    if (tmp_pos == end_of_line())
      break;
    if (the_char(tmp_pos) == '}')
      break;
    tmp_pos += 1;
  }
  if (the_char(tmp_pos) != '}')
    return;
  
  if ( javascript_pos_in_comment( re_cpp_begin_comment, re_cpp_end_comment, tmp_pos ) == 0 ) { 
    pos_blink = javascript_pos_blink_char ('{', '}');

    if (pos_blink != -1){
      pos = javascript_pos_line_blink(pos_blink);
      if (pos != pos_blink)
	pos_blink = pos;
      goto_char(orig);
      javascript_align_lines (pos_blink, orig);
    }
  }
}

/* ================================================================================
   Indent more if need
   ================================================================================ */
int javascript_indent_more_if_need () {
  
  int first_char_position, n;
  int more_indent = 0;
  
  /* Move to previous line at the first character not blank space or tab */
  goto_previous_line();
  goto_beginning_of_line();
  
  while(current_char()==' ' || current_char()=='\t'){
    if (current_position() == end_of_line())
      break;
    goto_next_char();
  }
  
  first_char_position = current_position();
  /* indent more if need */
  if (((re_forward_search(javascript_regexp_indent) == first_char_position)
       && javascript_pos_in_comment(re_cpp_begin_comment, 
			 re_cpp_end_comment, first_char_position) == 0
       && (javascript_last_char_in_line() != ';') 
       && (javascript_last_char_in_line() != '}'))
      || (javascript_last_char_in_line() == '{')) {
    more_indent = 1;
    n = javascript_indent_step;
    goto_next_line();
    goto_beginning_of_line();
    if ( javascript_first_char_in_line(current_line()) != '{') {
      while (n--){
	insert_char(' ');
      }
    }
    if ( javascript_first_char_in_line(current_line()) == '{' 
	&& javascript_last_char_in_line() == '}' ) {
      n = javascript_indent_step;
      while (n--){
	insert_char(' ');
      }
    }
  }
  else
    goto_next_line(); /* return to current line */
  return more_indent;
}

/* ================================================================================
   Indent less if need. (instruction sur 2 lignes prcdent la ligne courante)
   ================================================================================ */
void javascript_indent_less_if_need () {
  
  int first_char_position, tmp_pos;

  goto_previous_line();
  goto_beginning_of_line();
  
  if ( javascript_pos_in_comment( re_cpp_begin_comment, 
    re_cpp_end_comment, current_position ()) == 1 ) {
      tmp_pos = re_backward_search(re_cpp_begin_comment);
      goto_next_line();
      if (tmp_pos >= 0)
        javascript_align_lines ( tmp_pos, current_position());
      return;
  }
  if (javascript_last_char_in_line() == ';' || javascript_last_char_in_line() == '}'){
    goto_previous_line();
    goto_beginning_of_line();
    while(current_char()==' ' || current_char()=='\t'){
      if (current_position() == end_of_line())
	break;
      goto_next_char();
    }
    first_char_position = current_position();
    if (re_forward_search(javascript_regexp_indent2) == first_char_position
	&& the_char(first_char_position) != '{'
	&& javascript_last_char_in_line() != '{') {
      goto_next_line();
      if (javascript_first_char_in_line(current_line()) != '}') {
	goto_next_line();
	javascript_align_lines( first_char_position, current_position());
      }
    }
  }
}

/* ================================================================================
   Indent switch case. (basic)
   ================================================================================ */
void javascript_indent_switch_case () {
  
  int pos, orig, line, first, n;

  line = current_line();
  orig = current_position();
  
  goto_beginning_of_line();
  pos = orig;
  while (1){
    if (pos == end_of_line())
      break;
    if (the_char(pos) == ' ' || the_char(pos) == '\t' )
      pos += 1;
    else {
      first = pos;
      break;
    }
  }

  pos = re_forward_search ("case\\|default");
  if ((pos == -1) || (pos == -2) || (first != pos) || (pos >= end_of_file())){
    goto_char(orig);
    return;
  }

  goto_previous_line();
  goto_beginning_of_line();
  pos = current_position();
  while (1){
    if (pos == end_of_line())
      break;
    if (the_char(pos) == ' ' || the_char(pos) == '\t' )
      pos += 1;
    else {
      first = pos;
      break;
    }
  }
  pos = re_forward_search ("break");
  if ((pos == -1) || (pos == -2) || (first != pos) || (pos >= end_of_file())) {
    goto_char(orig);
    return;
  }
  /* Ok */
  goto_next_line();
  goto_beginning_of_line();
  
  n = javascript_indent_step;
  while (n--){
    if (current_char() == ' ')
      delete_char();
    else
      break;
  }
  goto_line(line);
}

/* ================================================================================
   Indent line. Entry point of main indent process.
   ================================================================================ */
void javascript_indent_line ()
{

  int orig = current_position();
  int pos = orig, n, indent_m = 0, c_line;
  int c, first_char_position, distance = 0, tmp_pos, pos_blink;

  if (current_line()==0)
    return;
  
  distance = javascript_distance_from_end_of_line(pos);
  
  /* check for close bracket */
  if ( javascript_first_char_in_line (current_line()) == '}' 
      /*|| javascript_last_char_in_line() == '}'*/ ){
    javascript_align_close_bracket(orig);
    goto_char(orig);
    /* distance = javascript_distance_from_end_of_line(current_position()); */
  }
  else {
    /* first align to previous line */
    javascript_align_to_previous_line();
    indent_m = javascript_indent_more_if_need ();
    
    c_line = current_line();
    /* Le cas d'une instruction sur 2 lignes */
    if (indent_m == 0) {
       javascript_indent_less_if_need();
    }
    goto_line (c_line);
    javascript_indent_switch_case ();
    /* goto_char(orig); */
    /* distance = javascript_distance_from_end_of_line(current_position()); */
  }

  /* Return to initial position */
  if (distance == 0)
    goto_end_of_line();
  else {
    goto_end_of_line();
    while(distance > 0){
      if (current_position() == beginning_of_line())
	break;
      goto_previous_char();
      distance -= 1;
    }
  }
  if (current_buffer_is_colored())
    javascript_color_region (beginning_of_line(), end_of_line());
}

/* ================================================================================
   Return and indent.
   ================================================================================ */
void javascript_new_line ()
{
  insert_char('\n');
  javascript_indent_line();
}

/* ================================================================================
   Indent region
   ================================================================================ */
void javascript_indent_region() {

  int init_line = current_line();
  int init_position = current_position();
  int mark_line, i, start_line, end_line;

  if (mark_position() == -1)
    return;
  
  watch_on();
  goto_mark();
  mark_line = current_line();
  if (mark_line > init_line){
    start_line = init_line;
    end_line = mark_line;
  }
  else {
    start_line = mark_line;
    end_line = init_line;   
  }
  goto_line(start_line);

  for (i=start_line; i < end_line; i++ ){
    javascript_indent_line();
    goto_next_line();
  }
  javascript_indent_line();
  goto_line (init_line);
  goto_beginning_of_line();

  watch_off();
  reset_mark();
}

/* ================================================================================
   Indent buffer
   ================================================================================ */
void javascript_indent_buffer() {
  
  int  pos, line = current_line();
  
  /* on passe le header (cpp comment) s'il existe */
  goto_char(0);
  pos = re_forward_search(re_cpp_begin_comment);
  if (pos == 0 || pos == 1) {
    pos = re_forward_search(re_cpp_end_comment);
    if (pos > 0) {
      goto_char(pos);
      goto_next_line();
      goto_beginning_of_line();
      set_mark(current_position());
    }
    else
      set_mark(0);
  }
  else
    set_mark(0);
  
  goto_end_of_file();
  
  javascript_indent_region();
  
  goto_line(line);
  goto_beginning_of_line();
  color_buffer();
  
  reset_mark();
}

/* ================================================================================
   Insert the char " ' and colorize
   ================================================================================ */
void javascript_insert_and_colorize ()
{
  insert_char(last_key());
  
  if (current_buffer_is_colored())
    javascript_color_region (beginning_of_line(), end_of_line());
}

/* ================================================================================
   Insert, blink matched char and indent if need
   ================================================================================ */
void javascript_insert_and_blink() {
  
  int orig, pos, tmp_pos;
  int c, c_char, blink_char, internal = 0;
  
  c = last_key();

  if (c == '}')
    blink_char = '{';
  else if (c == ']')
    blink_char = '[';
  else if (c == ')')
    blink_char = '(';
  else
    return;
   
  insert_char (c);
  orig = current_position();
  pos = orig;
  
  /* Check inside comment or string */ 
  if ( javascript_pos_in_comment( re_cpp_begin_comment, re_cpp_end_comment, pos ) == 1
      || javascript_pos_in_regexp ( "//.*$", 0, pos ) == 1 
      || javascript_pos_in_regexp ( javascript_string, 0, pos ) == 1 ) {
    return;
  }

  pos = javascript_pos_blink_char (blink_char, c);

  if ( pos == -1)
    return;
  else
    blink(pos);

  if (blink_char == '{'){
    /* indent if need */
    tmp_pos = javascript_pos_line_blink (pos);
    if (tmp_pos != pos)
      pos = tmp_pos;
    goto_char(orig);
    javascript_align_lines (pos, orig);
  }
}

/* ================================================================================
   Javascript key_def
   ================================================================================ */
{
  key_def("JavaScript", "\t", "javascript_indent_line");
  key_def("JavaScript", "\r", "javascript_new_line");
  key_def("JavaScript", " ", "javascript_insert_and_colorize");
  
  key_def("JavaScript", "\"", "javascript_insert_and_colorize");
  key_def("JavaScript", "\'", "javascript_insert_and_colorize");

  key_def("JavaScript", "}", "javascript_insert_and_blink");
  key_def("JavaScript", "]", "javascript_insert_and_blink");
  key_def("JavaScript", ")", "javascript_insert_and_blink");

  key_def("JavaScript", "^[i", "javascript_indent_region");
  
  key_def("JavaScript", "^[u", "upcase_word");
  key_def("JavaScript", "^[l", "downcase_word");
  key_def("JavaScript", "^[c", "capitalize_word");
}

